import pandas as pd

def prep_fever_data():
    fever_df = pd.read_csv("..\\datasets\\FEVER_train.txt", sep="\t", header=None)
    fever_df.columns = ["label", "context", "answer"]
    #fever_df["question"]=""
    fever_df["label_true"] = (fever_df["label"]=="entailment").astype(int)
    return fever_df
    
def prep_openai_data(): # 15k
    tldr1 = pd.read_json("..\\datasets\\summfeedback\\axis_evals\\tldraxis1.json", lines=True)
    tldr2 = pd.read_json("..\\datasets\\summfeedback\\axis_evals\\tldraxis2.json", lines=True)
    cnndm1 = pd.read_json("..\\datasets\\summfeedback\\axis_evals\\cnndm1.json", lines=True)
    cnndm3 = pd.read_json("..\\datasets\\summfeedback\\axis_evals\\cnndm3.json", lines=True)
    cnndm4 = pd.read_json("..\\datasets\\summfeedback\\axis_evals\\cnndm4.json", lines=True)

    tldr = pd.concat([tldr1, tldr2], axis=0)
    cnndm = pd.concat([cnndm1, cnndm3, cnndm4], axis=0)
    tldr["context"]=tldr["info"].map(lambda x:x["post"])
    cnndm["context"]=cnndm["info"].map(lambda x:x["article"])
    
    fulldf = pd.concat([tldr, cnndm], axis=0)
    fulldf["answer"]=fulldf["summary"].map(lambda x:x["text"])
    fulldf["axes"]=fulldf["summary"].map(lambda x:x["axes"])
    fulldf["has_acc"]=fulldf["axes"].map(lambda x:"accuracy" in x)
    fulldf = fulldf[fulldf["has_acc"]]
    fulldf.reindex
    fulldf["label_true"]=fulldf["axes"].map(lambda x:x["accuracy"])
    fulldf["label_true"] =fulldf["label_true"].astype(int)
    fulldf_input = fulldf[["context", "answer", "label_true"]]
    #fulldf_input["question"]=""
    return fulldf_input

def prep_docnli_data():
    docnli_df = pd.read_json("..\\datasets\\DocNLI_dataset\\train.json", orient='records')
    docnli_df.columns = ["context", "answer", "label"]
    #docnli_df["question"]=""
    docnli_df["label_true"] = (docnli_df["label"]=="entailment").astype(int)
    return docnli_df

def prep_mctest_data():
    mctest500 = pd.read_csv("..\\datasets\\mc500.train_in_entail.txt", sep="\t", header=None)
    mctest160 = pd.read_csv("..\\datasets\\mc160.train_in_entail.txt", sep="\t", header=None)
    mctest = pd.concat([mctest500, mctest160], axis=0)
    mctest.columns = ["label", "context", "answer"]
    #mctest["question"]=""
    mctest["label_true"] = (mctest["label"]=="entailment").astype(int)
    return mctest

def prep_mnli_data():
    mnli = pd.read_csv("..\\datasets\\mnli_train.txt", sep="\t", error_bad_lines=False, header=None)
    mnli.columns = ["label", "context", "answer"]
    #mnli["question"]=""
    mnli["label_true"] = (mnli["label"]=="entailment").astype(int)
    return mnli

